'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c27ce353.js');
const ionicGlobal = require('./ionic-global-4c058493.js');
require('./hardware-back-button-8c2f48d2.js');
require('./helpers-0a6f41ce.js');
require('./animation-c19d45b1.js');
const index$2 = require('./index-ba422979.js');
const menuToggleUtil = require('./menu-toggle-util-80ed66b7.js');

const menuToggleCss = ":host(.menu-toggle-hidden){display:none}";

const MenuToggle = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.visible = false;
        /**
         * Automatically hides the content when the corresponding menu is not active.
         *
         * By default, it's `true`. Change it to `false` in order to
         * keep `ion-menu-toggle` always visible regardless the state of the menu.
         */
        this.autoHide = true;
        this.onClick = () => {
            return index$2.menuController.toggle(this.menu);
        };
    }
    connectedCallback() {
        this.visibilityChanged();
    }
    async visibilityChanged() {
        this.visible = await menuToggleUtil.updateVisibility(this.menu);
    }
    render() {
        const mode = ionicGlobal.getIonMode(this);
        const hidden = this.autoHide && !this.visible;
        return (index.h(index.Host, { onClick: this.onClick, "aria-hidden": hidden ? 'true' : null, class: {
                [mode]: true,
                'menu-toggle-hidden': hidden,
            } }, index.h("slot", null)));
    }
};
MenuToggle.style = menuToggleCss;

exports.ion_menu_toggle = MenuToggle;
