import { Component, h, Prop } from '@stencil/core';
import "@ionic/core";
export class ProfileView {
    render() {
        const { name, location, role, imageSrc, homepage, note } = this.profile;
        return h("ion-card", null,
            h("ion-card-header", null,
                h("ion-avatar", null,
                    h("img", { src: imageSrc })),
                h("ion-card-title", null, name),
                h("ion-card-subtitle", null, role)),
            h("ion-card-content", null,
                h("ion-grid", null,
                    h("ion-row", null,
                        h("ion-col", { size: "12", "size-sm": true },
                            h("ion-icon", { name: "location-outline" }),
                            " ",
                            location),
                        h("ion-col", { size: "12", "size-sm": true },
                            h("ion-icon", { name: "globe-outline" }),
                            " ",
                            h("a", { href: homepage }, homepage))),
                    h("ion-row", null,
                        h("ion-col", { size: "12", "size-sm": true }, note)))));
    }
    static get is() { return "profile-view"; }
    static get encapsulation() { return "shadow"; }
    static get properties() { return {
        "profile": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "{ uri: string, name: string, location: string, role: string, imageSrc: string, note: string, homepage: string }",
                "resolved": "{ uri: string; name: string; location: string; role: string; imageSrc: string; note: string; homepage: string; }",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            }
        }
    }; }
}
